#ifndef __AXIS_GROUP__
#define __AXIS_GROUP__

namespace XMLIOSERVER
{
   class AxisGroup : public GroupTemplate<CAxis, AxisAttribut>
   {
      public:

         AxisGroup(void) : GroupTemplate<CAxis, AxisAttribut>()
         {/* Ne rien faire de plus */}
         AxisGroup(const string& _id) : GroupTemplate<CAxis, AxisAttribut>(_id)
         {/* Ne rien faire de plus */}

         void parse (XMLNode& _node, bool _withAttr = true)
         {
            string name = _node.getElementName();
            THashAttributes attributes;

            /// PARSING GESTION DES ATTRIBUTS ///
            if (_withAttr)
            {
               _node.getAttributes(attributes);
               this->setAttributes(attributes);

               if (attributes.end() != attributes.find("src"))
               { // Si une demande d'inclusion de fichier est trouvée.
                  XMLNode _node_inc = getNodeIncludedFile(attributes["src"], name);
                  parse (_node_inc);
               }
               attributes.clear();
            }

            /// PARSING POUR GESTION DES ENFANTS
            if (!(_node.goToChildElement()))
               WARNING("Le groupe d'axes ne contient pas d'enfant !");
            else
            {
               //////////////////////////////////////
               do { // Parcours pour traitement.

                  string name = _node.getElementName();
                  attributes.clear();
                  _node.getAttributes(attributes);

                  if (name.compare(AxisGroup::GetName()) == 0)
                  { createGroupAndParse<AxisGroup>(attributes, _node); continue; }

                  if (name.compare(CAxis::GetName()) == 0)
                  { createChildAndParse<CAxis>(attributes, _node); continue; }

                  WARNING("Un groupe d'axes ne peut contenir qu'un axe ou un autre groupe d'axes !");

               } while (_node.goToNextElement());
               //////////////////////////////////////
               _node.goToParentElement(); // Retour au parent
            }
         }

         virtual ~AxisGroup(void)
         {/* Ne rien faire de plus */ }

   }; // class AxisGroup

   typedef AxisGroup AxisDefinition ;

}; // namespace XMLIOSERVER

#endif // __AXIS_GROUP__

