#ifndef __FIELD_GROUP__
#define __FIELD_GROUP__

namespace XMLIOSERVER
{
   class FieldGroup : public GroupTemplate<CField, FieldAttribut>
   {
      public:

         FieldGroup(void) : GroupTemplate<CField, FieldAttribut>()
         {/* Ne rien faire de plus */}
         FieldGroup(const string& _id) : GroupTemplate<CField, FieldAttribut>(_id)
         {/* Ne rien faire de plus */}

         void parse (XMLNode& _node, bool _withAttr = true)
         {
            string name = _node.getElementName();
            THashAttributes attributes;

            /// PARSING GESTION DES ATTRIBUTS ///
            if (_withAttr)
            {
               _node.getAttributes(attributes);
               this->setAttributes(attributes);

               if (attributes.end() != attributes.find("src"))
               { // Si une demande d'inclusion de fichier est trouvée.
                  XMLNode _node_inc = getNodeIncludedFile(attributes["src"], name);
                  parse (_node_inc);
               }
               attributes.clear();
            }

            /// PARSING POUR GESTION DES ENFANTS
            if (!(_node.goToChildElement()))
               WARNING("Le groupe de champ ne contient pas d'enfant !");
            else
            {
               //////////////////////////////////////
               do { // Parcours pour traitement.

                  string name = _node.getElementName();
                  attributes.clear();
                  _node.getAttributes(attributes);

                  if (name.compare(FieldGroup::GetName()) == 0)
                  { createGroupAndParse<FieldGroup>(attributes, _node); continue; }

                  if (name.compare(CField::GetName()) == 0)
                  { createChildAndParse<CField>(attributes, _node); continue; }

                  WARNING("Un groupe de champs ne peut contenir qu'un champ ou un autre groupe de champs !");

               } while (_node.goToNextElement());
               //////////////////////////////////////
               _node.goToParentElement(); // Retour au parent
            }
         }

         virtual ~FieldGroup(void)
         {/* Ne rien faire de plus */ }

   }; // class FieldGroup

   typedef FieldGroup FieldDefinition ;

}; // namespace XMLIOSERVER

#endif // __FIELD_GROUP__

