#ifndef __FILE_GROUP__
#define __FILE_GROUP__

namespace XMLIOSERVER
{
   class FileGroup : public GroupTemplate<CFile, FileAttribut>
   {
      public:

         FileGroup(void) : GroupTemplate<CFile, FileAttribut>()
         {/* Ne rien faire de plus */}
         FileGroup(const string& _id) : GroupTemplate<CFile, FileAttribut>(_id)
         {/* Ne rien faire de plus */}

         void parse (XMLNode& _node, bool _withAttr = true)
         {
            string name = _node.getElementName();
            THashAttributes attributes;

            /// PARSING GESTION DES ATTRIBUTS ///
            if (_withAttr)
            {
               _node.getAttributes(attributes);
               this->setAttributes(attributes);

               if (attributes.end() != attributes.find("src"))
               { // Si une demande d'inclusion de fichier est trouvée.
                  XMLNode _node_inc = getNodeIncludedFile(attributes["src"], name);
                  parse (_node_inc);
               }

               attributes.clear();
            }

            /// PARSING POUR GESTION DES ENFANTS ///
            if (!(_node.goToChildElement()))
               WARNING("Le groupe de fichier ne contient pas d'enfant !");
            else
            {
               //////////////////////////////////////
               do { // Parcours  pour traitement.

                  string name = _node.getElementName();
                  attributes.clear();
                  _node.getAttributes(attributes);

                  if (name.compare(FileGroup::GetName()) == 0)
                  { createGroupAndParse<FileGroup>(attributes, _node); continue; }

                  if (name.compare(CFile::GetName()) == 0)
                  { createChildAndParse<CFile>(attributes, _node) ; continue; }

                  WARNING("Un groupe de fichiers ne peut contenir qu'un fichier ou un autre groupe de fichiers !");

               } while (_node.goToNextElement());
               //////////////////////////////////////
               _node.goToParentElement(); // Retour au parent
            }
         }

         virtual ~FileGroup(void)
         {/* Ne rien faire de plus */ }

   }; // class FileGroup

   typedef FileGroup FileDefinition ;

}; // namespace XMLIOSERVER

#endif // __FILE_GROUP__

